<?php
namespace Teknisa\GOP\Services;

 use Zeedhi\Framework\DataSource\DataSet;
 use Zeedhi\Framework\DTO;


class Gop01100ComparacaoVersoesOrcamentoService{
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function getVersoes($params){
        $select = "SELECT COUNT(DISTINCT I.CDVERSAOGOP) VERSOES
					 FROM VERSAOGOP V, ITVERSAOGOP I
					WHERE NRANOVERSAOGOP = :NRANOVERSAOGOP
                      AND NRPERIODOORCA  = :NRPERIODOORCA
                      AND IDPERIODOORCA  = :IDPERIODOORCA
                      AND I.CDFILIAL     = :CDFILIAL
                      AND I.NRVERSAOGOP  = V.NRVERSAOGOP";
        try{
            
            $std = $this->connection->prepare($select);
            $std->execute($params); //apenas executa
            $retorno = $std->fetchAll();  //retorna
            return $retorno[0]['VERSOES'];
            
        }catch (Exception $e){
            throw $e;
        }
    }
    
    public function getDataDetalhamento($versoes, $versoesFil, $params){
        $select = 
			"SELECT * FROM (
			 (SELECT DISTINCT F.CDFILIAL ID, (F.CDFILIAL||' - '||F.NMFILIAL) NOME, NULL PARENT, F.CDFILIAL,
                     NULL IDITEMVERSAOGOP, F.NRORG,  NULL CDTIPOITVERSAOGOP, " . $versoesFil . "
                FROM FILIAL F INNER JOIN FILIOPER FO ON F.CDFILIAL = FO.CDFILIAL
                              INNER JOIN VERSAOGOP V ON F.CDFILIAL = V.CDFILIAL
               WHERE F.CDFILIAL = :P_CDFILIAL 
                 AND FO.CDOPERADOR = :P_CDOPERADOR)

               UNION

			 (SELECT * 
			    FROM (SELECT (I.CDFILIAL||'_'||I.IDITEMVERSAOGOP||'_'||'NRITVERSAOGOP') ID,
                             CASE IDITEMVERSAOGOP                          
                             WHEN 'MAOOBRA' THEN 'Mão de Obra'
                             WHEN 'DESPMATRIZ' THEN 'Matriz'
                             WHEN 'DESPDIVERSA' THEN 'Diversa'
                             WHEN 'DESPENTRADA' THEN 'Lançamento de Entrada'
                             WHEN 'INVESTIMENTO' THEN 'Investimento'
                             WHEN 'DEPRECIACAO' THEN 'Depreciação'
                             WHEN 'IMPOSTOARECUPERAR' THEN 'A recuperar'
                             WHEN 'IMPOSTOSOBLUCRO' THEN 'Sob o lucro'
                             WHEN 'IMPOSTO' THEN 'Faturamento'
                             WHEN 'TAXAADM' THEN 'Taxa Administrativa'
                             ELSE INITCAP(IDITEMVERSAOGOP) END NOME, ('Versao ' || I.CDVERSAOGOP) CDVERSAOGOP,
                             CASE IDITEMVERSAOGOP
                             WHEN 'MAOOBRA' THEN 'DESPESA'||I.CDFILIAL
                             WHEN 'DESPMATRIZ' THEN 'DESPESA'||I.CDFILIAL
                             WHEN 'DESPDIVERSA' THEN 'DESPESA'||I.CDFILIAL
                             WHEN 'DESPENTRADA' THEN 'DESPESA'||I.CDFILIAL
                             WHEN 'INVESTIMENTO' THEN 'DESPESA'||I.CDFILIAL
                             WHEN 'DEPRECIACAO' THEN 'DESPESA'||I.CDFILIAL
                             WHEN 'IMPOSTOARECUPERAR' THEN 'IMPOSTO'||I.CDFILIAL
                             WHEN 'IMPOSTOSOBLUCRO' THEN 'IMPOSTO'||I.CDFILIAL
                             WHEN 'IMPOSTO' THEN 'IMPOSTO'||I.CDFILIAL
                             ELSE I.CDFILIAL END PARENT, I.CDFILIAL, I.IDITEMVERSAOGOP,
                             NVL(I.VRITEMVERSAO, 0) VRITEMVERSAO, I.NRORG, NULL CDTIPOITVERSAOGOP
                FROM ITVERSAOGOP I, VERSAOGOP V
               WHERE V.NRVERSAOGOP = I.NRVERSAOGOP
                 AND I.CDFILIAL = :P_CDFILIAL
                 AND 'Versao '||I.CDVERSAOGOP IN (". $versoes .")
                ) PIVOT (SUM(NVL(VRITEMVERSAO, 0)) 
                    FOR CDVERSAOGOP IN (". $versoes .")))

               UNION 

             (SELECT * 
                FROM (SELECT (IV.CDFILIAL||'_'||'TIPOITVERSAOGOP'||T.CDTIPOITVERSAOGOP) ID, T.NMTIPOITVERSAOGOP NOME, 
                             ('Versao ' || IV.CDVERSAOGOP) CDVERSAOGOP,
                             (IV.CDFILIAL||'_'||IV.IDITEMVERSAOGOP||'_'||'NRITVERSAOGOP') PARENT,
                             IV.CDFILIAL, IV.IDITEMVERSAOGOP, T.NRORG, TO_CHAR(T.CDTIPOITVERSAOGOP) CDTIPOITVERSAOGOP, NVL(TO_NUMBER(T.VRTIPOITVERSAOGOP), 0) VRTIPOITVERSAOGOP
                        FROM TIPOITVERSAOGOP T, ITVERSAOGOP IV
                       WHERE IV.NRITVERSAOGOP = T.NRITVERSAOGOP
                         AND IV.CDFILIAL = :P_CDFILIAL
                         AND 'Versao '||IV.CDVERSAOGOP IN (". $versoes .")
                    ) PIVOT (SUM(NVL(VRTIPOITVERSAOGOP, 0)) FOR CDVERSAOGOP IN (". $versoes .")))

               UNION

            (SELECT *  
               FROM (SELECT P.CDPRODTIPOITVERSAOGOP||'PRODTIPOITVERSAOGOP' ID, P.NMPRODTIPOITVERSAOGOP NOME,  
                            ('Versao ' || IV.CDVERSAOGOP) CDVERSAOGOP,
                            (IV.CDFILIAL||'_'||'TIPOITVERSAOGOP'||T.CDTIPOITVERSAOGOP) PARENT,
                            IV.CDFILIAL, IV.IDITEMVERSAOGOP,   T.NRORG, P.CDPRODTIPOITVERSAOGOP CDTIPOITVERSAOGOP, NVL(P.VRPRODTIPOITVERSAOGOP, 0) VRPRODTIPOITVERSAOGOP
                       FROM PRODTIPOITVERSAOGOP P, TIPOITVERSAOGOP T, ITVERSAOGOP IV
                      WHERE IV.NRITVERSAOGOP = T.NRITVERSAOGOP
                        AND P.NRTIPOITVERSAOGOP = T.NRTIPOITVERSAOGOP 
                        AND IV.CDFILIAL = :P_CDFILIAL
                        AND 'Versao '||IV.CDVERSAOGOP IN (". $versoes .")
                    ) PIVOT (SUM(NVL(VRPRODTIPOITVERSAOGOP, 0)) FOR CDVERSAOGOP IN (". $versoes .")))
            ) ORDER BY ID, CASE NOME WHEN 'FATURAMENTO' THEN 1 WHEN 'CONSUMO' THEN 2 WHEN 'MAOOBRA' THEN 3 WHEN 'DESPMATRIZ' THEN 4 WHEN 'DESPENTRADA' THEN 5 WHEN 'DESPDIVERSA' THEN 6 WHEN 'IMPOSTO' THEN 7 WHEN 'IMPOSTOARECUPERAR' THEN 8 WHEN 'IMPOSTOSOBLUCRO' THEN 9 WHEN 'INVESTIMENTO' THEN 10 WHEN 'DEPRECIACAO' THEN 11 WHEN 'TAXAADM' THEN 12 ELSE 0 END";
       
        try{
            $std = $this->connection->prepare($select);
            $std->execute($params); //apenas executa
            $retorno = $std->fetchAll();  //retorna
            return $retorno;
        }catch (Exception $e){
            throw $e;
        }
    }
}